unit UnitDsolve;

{$mode objfpc}{$H+}

interface

uses
   Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs,Symbolic,  LCLType,lsoda;

type
  extendedarray=array of extended;
  integerarray=array of integer;
  extendedarray2D=array of array of extended;
  integerarray2D=array of array of integer;
  stringarray=array of string;
  arrayexpression=array of texpression;
  arrayexpression2D=array of array of texpression;
  arrayTStringList=array of TStringList;
  arrayTEvaluator=array of TEvaluator ;
  arrayTEvaluator2D=array of array of TEvaluator ;
   booleanarray=array of boolean;
  Solveur_Cinetique = class
    private
   var parser_lois_vitesse:arrayTEvaluator;
  parser_jacobien:arrayTEvaluator2D;
  expressions_lois_vitesse:stringarray;
  Texpressions_lois_vitesse:arrayexpression;
  Texpressions_jacobien:arrayexpression2D;
  noms_especes:stringarray;   partiel:string;
  Liste_Variables : arrayTStringList;    pas,date:extended;

   Vars    : Array OF ArbFloat;      res:extendedarray2D;

   nbe_reactions,nbe_especes:integer; ctes_vitesse:extendedarray;
   coef_stoechio,ordres_partiels:extendedarray2D; conc_ini:extendedarray; t0,tmax:extended; nbe_dates:integer;
    conc_ctes:booleanarray;

    sol_ode: Solveur_ODE;

     procedure Calcule_les_dc_sur_dt(neq:integer; t:extended;y:array of extended; var ydot:array of extended);
      procedure Calcule_Le_Jacobien( neq:integer; t:extended;y:array of extended; ML,MU:integer;var PD:extendedarrayarray; NROWPD:integer);

   public

constructor Create(_nbe_reactions,_nbe_especes:integer; _ctes_vitesse:extendedarray;
   _coef_stoechio,_ordres_partiels:extendedarray2D; _conc_ini:extendedarray;
   _conc_ctes:booleanarray; _t0,_tmax:extended; _nbe_dates:integer);

     function IntegreCinetique(): extendedarray2D;

  end;


implementation

constructor Solveur_Cinetique.Create(_nbe_reactions,_nbe_especes:integer; _ctes_vitesse:extendedarray;
   _coef_stoechio,_ordres_partiels:extendedarray2D; _conc_ini:extendedarray;
   _conc_ctes:booleanarray; _t0,_tmax:extended; _nbe_dates:integer);

begin
 nbe_reactions:=_nbe_reactions;
 nbe_especes:=_nbe_especes;
 ctes_vitesse:=_ctes_vitesse;
  coef_stoechio:= _coef_stoechio;
  ordres_partiels:=_ordres_partiels;
  conc_ini:=_conc_ini;
  conc_ctes:=_conc_ctes;
  t0:=_t0;
  tmax:=_tmax;
  nbe_dates:=_nbe_dates;
     end;



procedure Solveur_Cinetique.Calcule_Le_Jacobien( neq:integer; t:extended;y:array of extended; ML,MU:integer;
var PD:extendedarrayarray; NROWPD:integer);
var i,j,k,n:integer;
begin
   for i:=1 to nbe_especes do begin
     setlength( Vars,Liste_Variables[i-1].Count);
     for j:=1 to Liste_Variables[i-1].Count do
     Vars[j-1]:=y[1+strtoint(copy(Liste_Variables[i-1][j-1],2,length(Liste_Variables[i-1][j-1])-1))-1];
     for j:=1 to nbe_especes   do
     PD[i,j]:=parser_jacobien[i-1,j-1].Evaluate(Vars)
             end;


     end;


  procedure Solveur_Cinetique.Calcule_les_dc_sur_dt(neq:integer; t:extended;y:array of extended; var ydot:array of extended);

  var i,j,k,n:integer;
    begin

      for i:=1 to nbe_especes do begin
     setlength( Vars,Liste_Variables[i-1].Count);
     for j:=1 to Liste_Variables[i-1].Count do
     Vars[j-1]:=y[1+strtoint(copy(Liste_Variables[i-1][j-1],2,length(Liste_Variables[i-1][j-1])-1))-1];

       ydot[i]:=parser_lois_vitesse[i-1].Evaluate(Vars)
        end;


      end;

function Solveur_Cinetique.IntegreCinetique(): extendedarray2D;

var i,j,k,n,inc:integer;   var Dates:extendedarray; var Valeurs,ValeursDerivees: extendedarrayarray;
 _RTOL,_ATOL:array of extended;



 begin

    setlength(res,nbe_dates,2*nbe_especes+1);
   pas:=(tmax-t0)/(nbe_dates-1);
   date:=t0;
      setlength(expressions_lois_vitesse,nbe_especes);
    setlength(noms_especes,nbe_especes);
{noms des especes, A1, A2,A3,...}
    for i:=1 to nbe_especes do
    noms_especes[i-1]:='A'+inttostr(i);

  {ecriture des lois de vitesse}
    for i:=1 to nbe_especes do  begin
     expressions_lois_vitesse[i-1]:='0';
     for k:=1 to nbe_reactions do
      if ((coef_stoechio[k-1][i-1]+coef_stoechio[k-1][i-1+nbe_especes]<>0))  then begin
      partiel:='1';

      for j:=1 to nbe_especes do if  (ordres_partiels[k-1][j-1]<>0) then
      if ordres_partiels[k-1][j-1]<>1 then
      if  (ordres_partiels[k-1][j-1]>0)  then
       partiel:=partiel+'*'+noms_especes[j-1]+'^'+floattostr(ordres_partiels[k-1][j-1])
       else
        partiel:=partiel+'*'+noms_especes[j-1]+'^('+floattostr(ordres_partiels[k-1][j-1])+')'
       else
        partiel:=partiel+'*'+noms_especes[j-1];

       for j:=1 to nbe_especes do if  (ordres_partiels[k-1][j-1+nbe_especes]<>0) then
      if ordres_partiels[k-1][j-1+nbe_especes]<>1 then
      if  (ordres_partiels[k-1][j-1+nbe_especes]>0)  then
       partiel:=partiel+'*'+noms_especes[j-1]+'^'+floattostr(ordres_partiels[k-1][j-1+nbe_especes])
       else
        partiel:=partiel+'*'+noms_especes[j-1]+'^('+floattostr(ordres_partiels[k-1][j-1+nbe_especes])+')'
       else
        partiel:=partiel+'*'+noms_especes[j-1];

       if partiel<>'1' then delete(partiel,1,2);
       partiel:=floattostr(ctes_vitesse[k-1])+'*'+partiel;

        if coef_stoechio[k-1][i-1]+coef_stoechio[k-1][i-1+nbe_especes]>1 then
       expressions_lois_vitesse[i-1]:=expressions_lois_vitesse[i-1]+'+'+floattostr(coef_stoechio[k-1][i-1]+coef_stoechio[k-1][i-1+nbe_especes])+'*'+partiel
       else    if coef_stoechio[k-1][i-1]+coef_stoechio[k-1][i-1+nbe_especes]=1
       then expressions_lois_vitesse[i-1]:=expressions_lois_vitesse[i-1]+'+'+partiel
       else    if coef_stoechio[k-1][i-1]+coef_stoechio[k-1][i-1+nbe_especes]=-1
       then expressions_lois_vitesse[i-1]:=expressions_lois_vitesse[i-1]+'-'+partiel
       else    if coef_stoechio[k-1][i-1]+coef_stoechio[k-1][i-1+nbe_especes]<-1
       then
       expressions_lois_vitesse[i-1]:=expressions_lois_vitesse[i-1]+floattostr(coef_stoechio[k-1][i-1]+coef_stoechio[k-1][i-1+nbe_especes])+'*'+partiel;
       end;
       if expressions_lois_vitesse[i-1]<>'0' then delete(expressions_lois_vitesse[i-1],1,1);
       if  expressions_lois_vitesse[i-1][1]='+' then  delete(expressions_lois_vitesse[i-1],1,1);
      { application.messagebox(pchar(expressions_lois_vitesse[i-1]),'',mb_ok); }
    {et si une espèce est imposée de conc cte:}
    if conc_ctes[i-1] then expressions_lois_vitesse[i-1]:='0';

    end;


    setlength(Texpressions_lois_vitesse,nbe_especes);
    for i:=1 to nbe_especes do
    Texpressions_lois_vitesse[i-1]:=TExpression.Create(expressions_lois_vitesse[i-1]);

    setlength(Liste_Variables,nbe_especes);
     for i:=1 to nbe_especes do
     Liste_Variables[i-1]:=Texpressions_lois_vitesse[i-1].SymbolicValueNames;


   {  for i:=1 to nbe_especes do
      for j:=1 to Liste_Variables[i-1].Count do
  application.messagebox(pchar(Liste_Variables[i-1][j-1]),'',mb_ok);  }




     setlength(parser_lois_vitesse,nbe_especes);
      for i:=1 to nbe_especes do
     parser_lois_vitesse[i-1]:=TEvaluator.Create( Liste_Variables[i-1],Texpressions_lois_vitesse[i-1]);

      setlength(Texpressions_jacobien,nbe_especes,nbe_especes);
       setlength(parser_jacobien,nbe_especes,nbe_especes);
        for i:=1 to nbe_especes do
        for j:=1 to nbe_especes do     begin
         inc:=Liste_Variables[i-1].IndexOf(noms_especes[j-1]);
         if inc<>-1 then
        Texpressions_jacobien[i-1,j-1]:=Texpressions_lois_vitesse[i-1].Derive(Liste_Variables[i-1][inc]) else
          Texpressions_jacobien[i-1,j-1]:=TExpression.Create('0');
         parser_jacobien[i-1,j-1]:=TEvaluator.Create( Liste_Variables[i-1],Texpressions_jacobien[i-1,j-1]);
        end;



     sol_ode:=Solveur_ODE.create(nbe_especes,@Calcule_les_dc_sur_dt,@Calcule_Le_Jacobien,True);
       setlength(_RTOL,nbe_especes); setlength(_ATOL,nbe_especes);
         for i:=1 to nbe_especes do begin
          _RTOL[i-1]:=1.49012e-8{1e-3};   _ATOL[i-1]:=1.49012e-8{1e-3};
          end;
     sol_ode.Integre(t0,tmax,nbe_dates,conc_ini,Dates,Valeurs,ValeursDerivees,4,_RTOL,_ATOL);
      for i:=1 to nbe_dates  do begin
       res[i-1,0]:=Dates[i-1];
       for j:=1 to nbe_especes do begin
        res[i-1,j]:=Valeurs[i-1,j-1];
       res[i-1,j+nbe_especes]:=ValeursDerivees[i-1,j-1];
       end; end;
      result:=res;
    end;








end.

